window.md5_hexcase = 0;

window.md5_b64pad = "";

window.md5_chrsz = 8;

md5 = function(r) {
return md5New(r);
};

hex_md5 = function(r) {
return binl2hex(core_md5(str2binl(r), r.length * md5_chrsz));
};

b64_md5 = function(r) {
return binl2b64(core_md5(str2binl(r), r.length * md5_chrsz));
};

str_md5 = function(r) {
return binl2str(core_md5(str2binl(r), r.length * md5_chrsz));
};

hex_hmac_md5 = function(r, n) {
return binl2hex(core_hmac_md5(r, n));
};

b64_hmac_md5 = function(r, n) {
return binl2b64(core_hmac_md5(r, n));
};

str_hmac_md5 = function(r, n) {
return binl2str(core_hmac_md5(r, n));
};

md5_vm_test = function() {
return "900150983cd24fb0d6963f7d28e17f72" == hex_md5("abc");
};

core_md5 = function(r, n) {
r[n >> 5] |= 128 << n % 32;
r[14 + (n + 64 >>> 9 << 4)] = n;
for (var d = 1732584193, m = -271733879, _ = -1732584194, t = 271733878, e = 0; e < r.length; e += 16) {
var f = d, i = m, h = _, c = t;
d = md5_ff(d, m, _, t, r[e + 0], 7, -680876936);
t = md5_ff(t, d, m, _, r[e + 1], 12, -389564586);
_ = md5_ff(_, t, d, m, r[e + 2], 17, 606105819);
m = md5_ff(m, _, t, d, r[e + 3], 22, -1044525330);
d = md5_ff(d, m, _, t, r[e + 4], 7, -176418897);
t = md5_ff(t, d, m, _, r[e + 5], 12, 1200080426);
_ = md5_ff(_, t, d, m, r[e + 6], 17, -1473231341);
m = md5_ff(m, _, t, d, r[e + 7], 22, -45705983);
d = md5_ff(d, m, _, t, r[e + 8], 7, 1770035416);
t = md5_ff(t, d, m, _, r[e + 9], 12, -1958414417);
_ = md5_ff(_, t, d, m, r[e + 10], 17, -42063);
m = md5_ff(m, _, t, d, r[e + 11], 22, -1990404162);
d = md5_ff(d, m, _, t, r[e + 12], 7, 1804603682);
t = md5_ff(t, d, m, _, r[e + 13], 12, -40341101);
_ = md5_ff(_, t, d, m, r[e + 14], 17, -1502002290);
m = md5_ff(m, _, t, d, r[e + 15], 22, 1236535329);
d = md5_gg(d, m, _, t, r[e + 1], 5, -165796510);
t = md5_gg(t, d, m, _, r[e + 6], 9, -1069501632);
_ = md5_gg(_, t, d, m, r[e + 11], 14, 643717713);
m = md5_gg(m, _, t, d, r[e + 0], 20, -373897302);
d = md5_gg(d, m, _, t, r[e + 5], 5, -701558691);
t = md5_gg(t, d, m, _, r[e + 10], 9, 38016083);
_ = md5_gg(_, t, d, m, r[e + 15], 14, -660478335);
m = md5_gg(m, _, t, d, r[e + 4], 20, -405537848);
d = md5_gg(d, m, _, t, r[e + 9], 5, 568446438);
t = md5_gg(t, d, m, _, r[e + 14], 9, -1019803690);
_ = md5_gg(_, t, d, m, r[e + 3], 14, -187363961);
m = md5_gg(m, _, t, d, r[e + 8], 20, 1163531501);
d = md5_gg(d, m, _, t, r[e + 13], 5, -1444681467);
t = md5_gg(t, d, m, _, r[e + 2], 9, -51403784);
_ = md5_gg(_, t, d, m, r[e + 7], 14, 1735328473);
m = md5_gg(m, _, t, d, r[e + 12], 20, -1926607734);
d = md5_hh(d, m, _, t, r[e + 5], 4, -378558);
t = md5_hh(t, d, m, _, r[e + 8], 11, -2022574463);
_ = md5_hh(_, t, d, m, r[e + 11], 16, 1839030562);
m = md5_hh(m, _, t, d, r[e + 14], 23, -35309556);
d = md5_hh(d, m, _, t, r[e + 1], 4, -1530992060);
t = md5_hh(t, d, m, _, r[e + 4], 11, 1272893353);
_ = md5_hh(_, t, d, m, r[e + 7], 16, -155497632);
m = md5_hh(m, _, t, d, r[e + 10], 23, -1094730640);
d = md5_hh(d, m, _, t, r[e + 13], 4, 681279174);
t = md5_hh(t, d, m, _, r[e + 0], 11, -358537222);
_ = md5_hh(_, t, d, m, r[e + 3], 16, -722521979);
m = md5_hh(m, _, t, d, r[e + 6], 23, 76029189);
d = md5_hh(d, m, _, t, r[e + 9], 4, -640364487);
t = md5_hh(t, d, m, _, r[e + 12], 11, -421815835);
_ = md5_hh(_, t, d, m, r[e + 15], 16, 530742520);
m = md5_hh(m, _, t, d, r[e + 2], 23, -995338651);
d = md5_ii(d, m, _, t, r[e + 0], 6, -198630844);
t = md5_ii(t, d, m, _, r[e + 7], 10, 1126891415);
_ = md5_ii(_, t, d, m, r[e + 14], 15, -1416354905);
m = md5_ii(m, _, t, d, r[e + 5], 21, -57434055);
d = md5_ii(d, m, _, t, r[e + 12], 6, 1700485571);
t = md5_ii(t, d, m, _, r[e + 3], 10, -1894986606);
_ = md5_ii(_, t, d, m, r[e + 10], 15, -1051523);
m = md5_ii(m, _, t, d, r[e + 1], 21, -2054922799);
d = md5_ii(d, m, _, t, r[e + 8], 6, 1873313359);
t = md5_ii(t, d, m, _, r[e + 15], 10, -30611744);
_ = md5_ii(_, t, d, m, r[e + 6], 15, -1560198380);
m = md5_ii(m, _, t, d, r[e + 13], 21, 1309151649);
d = md5_ii(d, m, _, t, r[e + 4], 6, -145523070);
t = md5_ii(t, d, m, _, r[e + 11], 10, -1120210379);
_ = md5_ii(_, t, d, m, r[e + 2], 15, 718787259);
m = md5_ii(m, _, t, d, r[e + 9], 21, -343485551);
d = safe_add2(d, f);
m = safe_add2(m, i);
_ = safe_add2(_, h);
t = safe_add2(t, c);
}
return Array(d, m, _, t);
};

md5_cmn = function(r, n, d, m, _, t) {
return safe_add2(bit_rol(safe_add2(safe_add2(n, r), safe_add2(m, t)), _), d);
};

md5_ff = function(r, n, d, m, _, t, e) {
return md5_cmn(n & d | ~n & m, r, n, _, t, e);
};

md5_gg = function(r, n, d, m, _, t, e) {
return md5_cmn(n & m | d & ~m, r, n, _, t, e);
};

md5_hh = function(r, n, d, m, _, t, e) {
return md5_cmn(n ^ d ^ m, r, n, _, t, e);
};

md5_ii = function(r, n, d, m, _, t, e) {
return md5_cmn(d ^ (n | ~m), r, n, _, t, e);
};

core_hmac_md5 = function(r, n) {
var d = str2binl(r);
d.length > 16 && (d = core_md5(d, r.length * md5_chrsz));
for (var m = Array(16), _ = Array(16), t = 0; t < 16; t++) {
m[t] = 909522486 ^ d[t];
_[t] = 1549556828 ^ d[t];
}
var e = core_md5(m.concat(str2binl(n)), 512 + n.length * md5_chrsz);
return core_md5(_.concat(e), 640);
};

safe_add2 = function(r, n) {
var d = (65535 & r) + (65535 & n);
return (r >> 16) + (n >> 16) + (d >> 16) << 16 | 65535 & d;
};

bit_rol = function(r, n) {
return r << n | r >>> 32 - n;
};

str2binl = function(r) {
for (var n = Array(), d = (1 << md5_chrsz) - 1, m = 0; m < r.length * md5_chrsz; m += md5_chrsz) n[m >> 5] |= (r.charCodeAt(m / md5_chrsz) & d) << m % 32;
return n;
};

binl2str = function(r) {
for (var n = "", d = (1 << md5_chrsz) - 1, m = 0; m < 32 * r.length; m += md5_chrsz) n += String.fromCharCode(r[m >> 5] >>> m % 32 & d);
return n;
};

binl2hex = function(r) {
for (var n = md5_hexcase ? "0123456789ABCDEF" : "0123456789abcdef", d = "", m = 0; m < 4 * r.length; m++) d += n.charAt(r[m >> 2] >> m % 4 * 8 + 4 & 15) + n.charAt(r[m >> 2] >> m % 4 * 8 & 15);
return d;
};

binl2b64 = function(r) {
for (var n = "", d = 0; d < 4 * r.length; d += 3) for (var m = (r[d >> 2] >> d % 4 * 8 & 255) << 16 | (r[d + 1 >> 2] >> (d + 1) % 4 * 8 & 255) << 8 | r[d + 2 >> 2] >> (d + 2) % 4 * 8 & 255, _ = 0; _ < 4; _++) 8 * d + 6 * _ > 32 * r.length ? n += md5_b64pad : n += "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(m >> 6 * (3 - _) & 63);
return n;
};

md5New = function(r) {
var n = function(r, n) {
return r << n | r >>> 32 - n;
}, d = function(r, n) {
var d, m, _, t, e;
_ = 2147483648 & r;
t = 2147483648 & n;
e = (1073741823 & r) + (1073741823 & n);
return (d = 1073741824 & r) & (m = 1073741824 & n) ? 2147483648 ^ e ^ _ ^ t : d | m ? 1073741824 & e ? 3221225472 ^ e ^ _ ^ t : 1073741824 ^ e ^ _ ^ t : e ^ _ ^ t;
}, m = function(r, n, d) {
return r & n | ~r & d;
}, _ = function(r, n, d) {
return r & d | n & ~d;
}, t = function(r, n, d) {
return r ^ n ^ d;
}, e = function(r, n, d) {
return n ^ (r | ~d);
}, f = function(r, _, t, e, f, i, h) {
r = d(r, d(d(m(_, t, e), f), h));
return d(n(r, i), _);
}, i = function(r, m, t, e, f, i, h) {
r = d(r, d(d(_(m, t, e), f), h));
return d(n(r, i), m);
}, h = function(r, m, _, e, f, i, h) {
r = d(r, d(d(t(m, _, e), f), h));
return d(n(r, i), m);
}, c = function(r, m, _, t, f, i, h) {
r = d(r, d(d(e(m, _, t), f), h));
return d(n(r, i), m);
}, o = function(r) {
for (var n, d = r.length, m = d + 8, _ = 16 * ((m - m % 64) / 64 + 1), t = Array(_ - 1), e = 0, f = 0; f < d; ) {
e = f % 4 * 8;
t[n = (f - f % 4) / 4] = t[n] | r.charCodeAt(f) << e;
f++;
}
e = f % 4 * 8;
t[n = (f - f % 4) / 4] = t[n] | 128 << e;
t[_ - 2] = d << 3;
t[_ - 1] = d >>> 29;
return t;
}, a = function(r) {
var n, d = "", m = "";
for (n = 0; n <= 3; n++) d += (m = "0" + (r >>> 8 * n & 255).toString(16)).substr(m.length - 2, 2);
return d;
}, u = function(r) {
r = r.toString().replace(/\x0d\x0a/g, "\n");
for (var n = "", d = 0; d < r.length; d++) {
var m = r.charCodeAt(d);
if (m < 128) n += String.fromCharCode(m); else if (m > 127 && m < 2048) {
n += String.fromCharCode(m >> 6 | 192);
n += String.fromCharCode(63 & m | 128);
} else {
n += String.fromCharCode(m >> 12 | 224);
n += String.fromCharCode(m >> 6 & 63 | 128);
n += String.fromCharCode(63 & m | 128);
}
}
return n;
};
return function(r) {
var n, m, _, t, e, g, s, l, b, v = Array();
r = u(r);
v = o(r);
g = 1732584193;
s = 4023233417;
l = 2562383102;
b = 271733878;
for (n = 0; n < v.length; n += 16) {
m = g;
_ = s;
t = l;
e = b;
g = f(g, s, l, b, v[n + 0], 7, 3614090360);
b = f(b, g, s, l, v[n + 1], 12, 3905402710);
l = f(l, b, g, s, v[n + 2], 17, 606105819);
s = f(s, l, b, g, v[n + 3], 22, 3250441966);
g = f(g, s, l, b, v[n + 4], 7, 4118548399);
b = f(b, g, s, l, v[n + 5], 12, 1200080426);
l = f(l, b, g, s, v[n + 6], 17, 2821735955);
s = f(s, l, b, g, v[n + 7], 22, 4249261313);
g = f(g, s, l, b, v[n + 8], 7, 1770035416);
b = f(b, g, s, l, v[n + 9], 12, 2336552879);
l = f(l, b, g, s, v[n + 10], 17, 4294925233);
s = f(s, l, b, g, v[n + 11], 22, 2304563134);
g = f(g, s, l, b, v[n + 12], 7, 1804603682);
b = f(b, g, s, l, v[n + 13], 12, 4254626195);
l = f(l, b, g, s, v[n + 14], 17, 2792965006);
s = f(s, l, b, g, v[n + 15], 22, 1236535329);
g = i(g, s, l, b, v[n + 1], 5, 4129170786);
b = i(b, g, s, l, v[n + 6], 9, 3225465664);
l = i(l, b, g, s, v[n + 11], 14, 643717713);
s = i(s, l, b, g, v[n + 0], 20, 3921069994);
g = i(g, s, l, b, v[n + 5], 5, 3593408605);
b = i(b, g, s, l, v[n + 10], 9, 38016083);
l = i(l, b, g, s, v[n + 15], 14, 3634488961);
s = i(s, l, b, g, v[n + 4], 20, 3889429448);
g = i(g, s, l, b, v[n + 9], 5, 568446438);
b = i(b, g, s, l, v[n + 14], 9, 3275163606);
l = i(l, b, g, s, v[n + 3], 14, 4107603335);
s = i(s, l, b, g, v[n + 8], 20, 1163531501);
g = i(g, s, l, b, v[n + 13], 5, 2850285829);
b = i(b, g, s, l, v[n + 2], 9, 4243563512);
l = i(l, b, g, s, v[n + 7], 14, 1735328473);
s = i(s, l, b, g, v[n + 12], 20, 2368359562);
g = h(g, s, l, b, v[n + 5], 4, 4294588738);
b = h(b, g, s, l, v[n + 8], 11, 2272392833);
l = h(l, b, g, s, v[n + 11], 16, 1839030562);
s = h(s, l, b, g, v[n + 14], 23, 4259657740);
g = h(g, s, l, b, v[n + 1], 4, 2763975236);
b = h(b, g, s, l, v[n + 4], 11, 1272893353);
l = h(l, b, g, s, v[n + 7], 16, 4139469664);
s = h(s, l, b, g, v[n + 10], 23, 3200236656);
g = h(g, s, l, b, v[n + 13], 4, 681279174);
b = h(b, g, s, l, v[n + 0], 11, 3936430074);
l = h(l, b, g, s, v[n + 3], 16, 3572445317);
s = h(s, l, b, g, v[n + 6], 23, 76029189);
g = h(g, s, l, b, v[n + 9], 4, 3654602809);
b = h(b, g, s, l, v[n + 12], 11, 3873151461);
l = h(l, b, g, s, v[n + 15], 16, 530742520);
s = h(s, l, b, g, v[n + 2], 23, 3299628645);
g = c(g, s, l, b, v[n + 0], 6, 4096336452);
b = c(b, g, s, l, v[n + 7], 10, 1126891415);
l = c(l, b, g, s, v[n + 14], 15, 2878612391);
s = c(s, l, b, g, v[n + 5], 21, 4237533241);
g = c(g, s, l, b, v[n + 12], 6, 1700485571);
b = c(b, g, s, l, v[n + 3], 10, 2399980690);
l = c(l, b, g, s, v[n + 10], 15, 4293915773);
s = c(s, l, b, g, v[n + 1], 21, 2240044497);
g = c(g, s, l, b, v[n + 8], 6, 1873313359);
b = c(b, g, s, l, v[n + 15], 10, 4264355552);
l = c(l, b, g, s, v[n + 6], 15, 2734768916);
s = c(s, l, b, g, v[n + 13], 21, 1309151649);
g = c(g, s, l, b, v[n + 4], 6, 4149444226);
b = c(b, g, s, l, v[n + 11], 10, 3174756917);
l = c(l, b, g, s, v[n + 2], 15, 718787259);
s = c(s, l, b, g, v[n + 9], 21, 3951481745);
g = d(g, m);
s = d(s, _);
l = d(l, t);
b = d(b, e);
}
return (a(g) + a(s) + a(l) + a(b)).toLowerCase();
}(r);
};